from __future__ import division
import sys, os
import random
import rabbyt
from pyglet.window import mouse, key
from pyglet.text import Label
from pyglet import font
import snowui


class PenguinControl:
    def __init__(self, view, ctrl):
        #rabbyt.Sprite.__init__(self, "data/info_bar.png")
        self.ctrl = ctrl
        self.view = view
        #self.shape.bottom = 0
        #self.x = view.width/2
        #self.y = 0
        #self.alpha = 0

        self.penguins = []

        self.unit_selection_sprite = rabbyt.Sprite("data/selectctrl.png")
        self.unit_selection_sprite.right = view.width
        self.unit_selection_sprite.bottom = 0
        self.num_workers = 0
        self.num_snowballers = 0
        self.labels = []
        self.sprites = []

        font.add_directory("data/")

    def render(self):
        self.unit_selection_sprite.render()
        for l in self.labels:
            l.draw()
        #if self.alpha > 0:
            #rabbyt.Sprite.render(self)
        rabbyt.render_unsorted(self.sprites)

    def collide(self, xy):
        x,y = xy
        r = rabbyt.collisions.aabb_collide_single(rabbyt.Quad((x,y,x,y)),
                [self.unit_selection_sprite])

        if r and x >= self.unit_selection_sprite.left:
            if y > self.unit_selection_sprite.bottom+95:
                # Snowballer.
                for p in self.penguins:
                    if p.unit_type != "snowballer":
                        p.selected = False
                        self.ctrl.selected_units.remove(p)
                self.select(self.ctrl.selected_units)
            elif y > self.unit_selection_sprite.bottom+31:
                # Worker.
                for p in self.penguins:
                    if p.unit_type != "worker":
                        p.selected = False
                        self.ctrl.selected_units.remove(p)
                self.select(self.ctrl.selected_units)
            else:
                # Disband
                pass

        return r

    def select(self, penguins):
        self.labels = []
        self.sprites = []
        self.penguins = list(penguins)
        self.scale_x = rabbyt.lerp(end=1, dt=.1)
        #self.alpha = 1

        self.num_workers = 0
        self.num_snowballers = 0

        for i,p in enumerate(self.penguins):
            if p.unit_type == "worker":
                self.num_workers += 1
            else:
                self.num_snowballers += 1

        if self.num_snowballers:
            self.labels.append(Label(str(self.num_snowballers),
                        x = self.unit_selection_sprite.right - 20,
                        y = self.unit_selection_sprite.top - 25,
                        font_size = 17,
                        font_name = "SerafettinCartoon",
                        color = (100,0,0,255)))

        if self.num_workers:
            self.labels.append(Label(str(self.num_workers),
                        x = self.unit_selection_sprite.right - 20,
                        y = self.unit_selection_sprite.top - 90,
                        font_size = 17,
                        font_name = "SerafettinCartoon",
                        color = (100,0,0,255)))

        for i, u_type in enumerate(["snowballer", "worker"]):
            if not self.num_workers and i == 1:
                continue
            if not self.num_snowballers and i == 0:
                continue

            s = rabbyt.Sprite(self.ctrl.scene.textures["walk_anim"].texture,
                shape=(32,32), tex_shape=(0,32/256,32/512,0))
            s.x = self.unit_selection_sprite.right - 32
            s.y = self.unit_selection_sprite.top - 60*i - 32
            s.alpha = rabbyt.lerp(start=0, end=1, dt=.4)
            self.sprites.append(s)
            sc = rabbyt.Sprite(self.ctrl.scene.textures[u_type+"walk_anim"].texture,
                shape=(32,32), tex_shape=(0,32/256,32/512,0))
            sc.x = s.attrgetter("x")
            sc.y = s.attrgetter("y")
            sc.alpha = rabbyt.lerp(start=0, end=1, dt=.4)
            if p.player:
                sc.rgb = p.player.color
            self.sprites.append(sc)

    def deselect(self):
        self.penguins = []
        self.sprites = []
        self.labels = []
        #self.alpha = 0
