

class PixNodeSet:
    def __init__(self, size, make_node=lambda:set()):
        self.node_size = size
        self.nodes = {}
        self.make_node = make_node

    def get(self, x, y):
        i = (int(x)//self.node_size, int(y)//self.node_size)
        return self._get_node(i)

    def _get_node(self, node_key):
        if not self.nodes.has_key(node_key):
            node = self.make_node()
            self.nodes[node_key] = node
        return self.nodes[node_key]

    def range(self, x1, y1, x2, y2):
        """
        A generator that yields all of the nodes in the given range.
        """
        x1 = int(x1)//self.node_size
        y1 = int(y1)//self.node_size
        x2 = int(x2)//self.node_size
        y2 = int(y2)//self.node_size

        for y in range(y1, y2+1):
            for x in range(x1, x2+1):
                yield self._get_node((x,y))