from pyglet.clock import Clock
import rabbyt, snowui
import sys

from lib import profiler as p

class Scene:
    def __init__(self):
        self._return = False
        if hasattr(self, "ctrl"):
            self.scene_handler.window.push_handlers(self.ctrl)
        self.clock = Clock()
        if "nofps" not in sys.argv:
            self.clock.set_fps_limit(45)
        self.scene_handler.window.push_handlers(self.clock)
        self.time = 0
        self.clock.schedule(self._addtime)

        if "debug" in sys.argv:
            self.clock.schedule_interval(lambda dt:p.dump("Game Loop"), 2.0)

        self.view = snowui.View(self.scene_handler.window)

    def __del__(self):
        if hasattr(self, "ctrl"):
            self.scene_handler.window.pull_handlers(self.ctrl)
        self.scene_handler.window.pull_handlers(self.clock)

    def _addtime(self, dt):
        self.time += dt

    def loop(self):
        self.clock.tick()
        assert p.push("Scene")
        assert p.push("dispatch_events")
        self.scene_handler.window.dispatch_events()
        assert p.pop()
        rabbyt.set_time(self.time)
        self.view.set_viewport()
        assert p.pop()
        return self._return
