from __future__ import division
import sys
import rabbyt
from pyglet.window import Window

from lib.scene import Scene

from lib import profiler as p
from lib.version import __version__

class SceneHandler:
    def __init__(self):
        # Get from settings file.
        self.window = Window(width=1024, height=768)
        self.window.set_caption("SnowballZ "+__version__)
        self.window.on_close = self.exit

        rabbyt.set_default_attribs()

    def run(self, scene):
        while True:
            scene = self.loop(scene)

    def exit(self):
        assert p.dump("Game Loop")
        sys.exit(0)

    def loop(self, scene):
        scene = scene(self)
        while True:
            r = scene.loop()
            if callable(r):
                assert p.dump("Game Loop")
                del scene
                return r
