from __future__ import division
import snowui
import rabbyt

class VictoryTimer(snowui.Widget):
    accessable_by_sbs = ["tick_for", "win_at"]

    def __init__(self, scene):
        height = len(scene.players)*12
        snowui.Widget.__init__(self, shape=(0,height,100,0), rgba=(1,1,1,.7),
            x=scene.ctrl.gui_view.width/2,
            y=scene.ctrl.gui_view.height-10-height)
        self.scene = scene
        self.tick_for = None
        self.win_at = 240

        self.tracker = {}
        self.bars = {}
        for i, p in enumerate(scene.players):
            self.tracker[p] = 0.0
            self.bars[p] = rabbyt.Sprite(shape=(0,10,1,0),
                    x=self.x+50, y=self.y+i*12,
                    rgb=p.color)

        self.scene.clock.schedule_interval(self.tick, 1)

        self.scene.ctrl.add(self)

    def tick(self, dt):
        if not self.tick_for:
            return
        self.tracker[self.tick_for] += dt
        self.bars[self.tick_for].shape.width = self.tracker[self.tick_for]/self.win_at*100
        for b in self.bars.values():
            b.shape.height = 5
        self.bars[self.tick_for].shape.height = 10

    def render(self):
        snowui.Widget.render(self)
        rabbyt.render_unsorted(self.bars.values())
