class MainMenu(object):
    def __init__(self, game):
        self.game = game
        self.view = game.view

        self.sections = []
        self.panels = []

    def section_login(self):
        w = self.view.width
        h = self.view.height
        p1 = Sprite("data/menu/panel.png", x=w/2, y=h/2)
        b1 = Sprite("data/menu/button_im_new.png", x=p1.x, y=p1.y+150)
        g1 = Sprite("data/menu/glow.png", x=b1.x, y=b1.y, alpha=.6)
        t1 = Sprite("data/menu/title_login.png", x=p1.left+20, y=p1.y+190)
        t1.shape.bottom = t1.shape.left = 0
        self.panels = [p1, g1, b1, t1]

        wiz = Widgetize(self.view)
        def im_new():
            section = 1
            self.view.x = rabbyt.ease(end=section*w, dt=500)
        wiz.as_button(b1, callback=im_new)

    def run(self):
        snow = Snowflakes(self)
        trees = TreeSet(self)

        bg = []
        for i in range(2):
            s = Sprite("data/bg"+str(i+1)+".png")
            #s.rgb = (.9,.9,1)
            x = rabbyt.lerp(1024*i, 1024*i, dt=1) - self.view.attrgetter("x")*.1
            s.x = rabbyt.wrap((-1024,self.view.width), x)
            s.shape.bottom = s.shape.left = 0
            bg.append(s)

        self.view.xy = 0,0

        while self.running:
            self.clock.tick(45)
            rabbyt.set_time(pygame.time.get_ticks())

            events = pygame.event.get()
            wiz.run(events)
            for event in events:
                if event.type == pygame.QUIT:
                    self.running = False
                    return
            self.view.set_viewport()
            rabbyt.clear((0.79,0.93,1,1))

            z = self.view.zoom
            x,y = self.view.xy
            w = self.view.width
            h = self.view.height

            self.view.set_viewport((0, h, w, 0))
            rabbyt.render_unsorted(bg)
            trees.render()
            snow.run(True)

            self.view.set_viewport((x, h*z+y ,w*z+x, y))
            for p in self.panels:
                p.render()

            pygame.display.flip()